dynvars.database <- local({ env <- attach(NULL); detach(2); env})
new.dynamic.env <- function()
    eval(quote((function() environment())()), env=get.dynamic.env())
get.dynamic.env <- function() {
    name <- "__DYNVAR_ENV__"
    n <- sys.nframe()
    if (n > 1)
        for (i in (n-1):1) {
            env <- sys.frame(i)
            if (exists(name, env = env))
                return(get(name, env = env))
        }
    dynvars.database
} 
make.dynvar.name <- function() {
    ur <- function() floor(runif(1,max=2^32-1))
    repeat {
        name <- paste("__DYNVAR__",ur(), ur(), ur(), ur(), sep = "")
        if (! exists.dynvar.name(name))
            return(name)
    }
}
exists.dynvar.name <- function(name)
    exists(name, env = dynvars.database)
do.dynvar <- function(name, value, init, dynamic.environment) {
    if (! exists.dynvar.name(name))
        assign(name, init, env = dynvars.database)
    if (missing(value))
        get(name, env = get.dynamic.env())
    else if (missing(dynamic.environment))
        assign(name, value, env = get.dynamic.env(), inherits = TRUE)
    else
        assign(name, value, env = dynamic.environment, inherits = FALSE)
}
dynamic.bind <- function(expr, ...) {
    values <- list(...)
    "__DYNVAR_ENV__" <- denv <- new.dynamic.env()
    penv <- parent.frame()
    names <- names(values)
    for (i in seq(along = names))
        get(names[[i]], env = penv)(values[[i]], dynamic.environment = denv)
    expr
}
dynamic.bind.list <- function(expr, variables, values) {
    variables <- as.list(variables) # forces evaluation in the
    values <- as.list(values)       # caller's dynamic context
    "__DYNVAR_ENV__" <- denv <- new.dynamic.env()
    for (i in seq(along = variables))
        variables[[i]](values[[i]], dynamic.environment = denv)
    expr
}
dynamic.variable <- function(init = NULL, name = make.dynvar.name()) {
    if (exists(name, env = dynvars.database))
        warning(paste("dynamic variable \"", name, "\" already exists",sep=""))
    assign(name, init, env = dynvars.database)
    f <- function(newval, ..., dynamic.environment)
        do.dynvar(name, newval, init, dynamic.environment)
    body(f) <- 
        substitute(do.dynvar(name, newval, quote(init), dynamic.environment))
    f
}
